diff --git tests/pdumpfs-test tests/pdumpfs-test
index 977f569..73d627d 100755
--- tests/pdumpfs-test
+++ tests/pdumpfs-test
@@ -1,5 +1,9 @@
 #! /bin/sh
 
+DATE=date
+# prefer coreutils' GNU date with prefix "g"
+which gdate >/dev/null && DATE=gdate
+
 function mode_type {
   ruby -e "printf %Q(%o:%s\n), File.stat(%q($1)).mode, File.ftype(%q($1))"
 }
@@ -12,8 +16,14 @@ cd src
 ln -s foo foobar
 cd ..
 
-today=`date +%Y/%m/%d`
-yesterday=`date --date '1 day ago' +%Y/%m/%d`
+today=`$DATE +%Y/%m/%d`
+if $DATE --date '1 day ago' +%Y/%m/%d >/dev/null 2>&1; then
+	yesterday=`$DATE --date '1 day ago' +%Y/%m/%d`
+else
+	todaysec=`$DATE +%s`
+	yesterdaysec=`expr $todaysec - 86400`
+	yesterday=`$DATE -r $yesterdaysec  +%Y/%m/%d`
+fi
 
 ../pdumpfs src dest > tmp.log || exit 1
 diff -r src dest/$today/src || exit 1
